package com.oliveunion.addressbook;

import androidx.appcompat.app.AppCompatActivity;

import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.net.URLEncoder;

import javax.xml.transform.Result;

public class MainActivity extends AppCompatActivity {

    TextView textName = null;
    TextView textAddress = null;
    TextView textZip = null;
    TextView textTel = null;
    TextView textSearch = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        findViewById(R.id.btnSearch).setOnClickListener(mSearchClickListener);
        textName = (TextView)findViewById(R.id.textEditName);
        textAddress = (TextView)findViewById(R.id.textEditAddress);
        textZip = (TextView) findViewById(R.id.textEditZIP);
        textTel = (TextView)findViewById(R.id.textEditTel);
        textSearch = (TextView)findViewById(R.id.editSearch);
    }

    String addressJsonStr = null;

    public void parseAddress() {
        try {
                JSONObject jsonObject = new JSONObject(String.valueOf(addressJsonStr));

                Address address = new Address();
                address.setName(jsonObject.getString("name"));
                address.setAddress(jsonObject.getString("address"));
                address.setZip(jsonObject.getString("zip"));
                address.setTel(jsonObject.getString("tel"));

                Log.d("address", address.toString());

                textName.setText(address.getName());
                textAddress.setText(address.getAddress());
                textZip.setText(address.getZip());
                textTel.setText(address.getTel());

            }
            catch (JSONException e) {
                e.printStackTrace();
            }
    }

    public void sendSearchRequest() {
        URL url = null;
        try {
            url = new URL("http://in.oliveapi.com:8080/address");
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }
        HttpURLConnection urlConnection = null;
        try {
            urlConnection = (HttpURLConnection)url.openConnection();
            urlConnection.setDoOutput(true);
            urlConnection.setRequestMethod("POST");
            OutputStreamWriter body = new OutputStreamWriter(urlConnection.getOutputStream());
            body.write("{ \"name\": \"" + textSearch.getText() + "\" }");
            body.flush();

            int statusCode = 0;
            statusCode = urlConnection.getResponseCode();

            if (statusCode ==  200) {
                InputStream it = null;
                try {
                    it = new BufferedInputStream(urlConnection.getInputStream());
                } catch (IOException e) {
                    e.printStackTrace();
                }
                InputStreamReader read = new InputStreamReader(it);
                BufferedReader buff = new BufferedReader(read);
                StringBuilder dta = new StringBuilder();
                String chunks ;
                while(true)
                {
                    try {
                        if (!((chunks = buff.readLine()) != null)) break;
                        dta.append(chunks);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                Log.d("received", String.valueOf(dta));
                addressJsonStr = String.valueOf(dta);
                //Toast.makeText(getApplicationContext(), "received", Toast.LENGTH_LONG).show();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    Button.OnClickListener mSearchClickListener = new View.OnClickListener() {
        @Override
        public void onClick(View view) {
            Toast.makeText(getApplicationContext(), "Search Address", Toast.LENGTH_LONG).show();

            new ThreadTask<Integer, Integer>() {
                @Override
                protected void onPreExecute() {
                }

                @Override
                protected Integer doInBackground(Integer arg) {
                    sendSearchRequest();
                    return 0;
                }

                @Override
                protected void onPostExecute(Integer result) {
                    parseAddress();
                }
            }.execute(4);

        }
    };

}